public class Counter implements Runnable
{
    private int counter = 0;

    // increment counter by one
    public void run() {
        try {
            sem.down();
            int cnt = counter;
            counter = cnt + 1;
        } catch (InterruptedException e) {
            System.out.println("Interrupted while holding permission.");
        } finally {
            sem.up();
        }
    }

    // current value of counter
    public int counter() {
        return counter;
    }

    private Semaphore sem = new SemaphoreBusy(1);
}
